import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
var BASE_CLASS = 'sui-MoleculeButtonGroup';

var getGroupPosition = function getGroupPosition(groupPositions, numChildren, index) {
  if (index === 0) return groupPositions.FIRST;
  if (index === numChildren - 1) return groupPositions.LAST;
  return groupPositions.MIDDLE;
};

var MoleculeButtonGroup = function MoleculeButtonGroup(_ref) {
  var children = _ref.children,
      fullWidth = _ref.fullWidth,
      groupPositions = _ref.groupPositions,
      props = _objectWithoutPropertiesLoose(_ref, ["children", "fullWidth", "groupPositions"]);

  var numChildren = children.length;
  var getGroupPositionByIndex = getGroupPosition.bind(null, groupPositions, numChildren);
  var extendedChildren = React.Children.toArray(children).filter(Boolean).map(function (child, index) {
    var groupPosition = getGroupPositionByIndex(index);
    return React.cloneElement(child, _objectSpread({}, props, {
      groupPosition: groupPosition,
      fullWidth: fullWidth
    }));
  });
  return React.createElement("div", {
    className: cx(BASE_CLASS, fullWidth && BASE_CLASS + "--fullWidth")
  }, extendedChildren);
};

MoleculeButtonGroup.displayName = 'MoleculeButtonGroup';
MoleculeButtonGroup.defaultProps = {
  groupPositions: {
    FIRST: 'first',
    MIDDLE: 'middle',
    LAST: 'last'
  }
};
export default MoleculeButtonGroup;